#include "MyAnalysis.hh"
#include "G4RunManager.hh" 


MyAnalysis* MyAnalysis::instance = 0;

 
MyAnalysis::MyAnalysis() {

  // Declare and open here the histograms and/or ntuples.

 // necessary for root ?
  static TROOT rootBase("simple","Test pour voir ou ca va?");

  #ifdef ToFile
  outfile.open ("test.txt", ofstream::out); // | ofstream::app);
  #endif
  
  // root stuff initialyzing

  rootfile = new TFile("test.root","RECREATE");//,"UPDATE");//
  ntuple= new TNtuple("ntuple","left ntuple","energyDeposited:x:y:z:Particuleenergy");

  tree= new TTree("tree","left+right");
  blm=tree->Branch("left",&left.x,"x/D:y/D:z/D:energyDeposited/D:Particuleenergy/D");//:name/C");
  partName=tree->Branch("particule",&particule.name,"name/C");
   }


MyAnalysis::~MyAnalysis() {

  // Close here the histograms and/or ntuples.
  #ifdef ToFile
  outfile.close();
  #endif

  // write Root file
  rootfile->Close();
  delete rootfile;

}


MyAnalysis* MyAnalysis::getInstance() {
  if ( instance == 0 ) instance = new MyAnalysis();
  return instance;
}

void MyAnalysis::fill(const G4String type,const G4double energyDeposited, 
    const G4ThreeVector pos,const G4double Particuleenergy) {

   left.x=pos.x();
   left.y=pos.y();
   left.z=pos.z();
   left.energyDeposited = energyDeposited;
   left.Particuleenergy = Particuleenergy;
   std::strcpy(particule.name,type);
   tree->Fill();
}

void MyAnalysis::endofrun() { rootfile->Write(); }

void MyAnalysis::dispose()
{
  if (instance != 0)
  {
    delete instance;
    instance = 0;
  }
}
